Subject: Re: [PATCH net-next v2 1/3] net: macb: fix SGMII with inband aneg disabled

From: "Russell King (Oracle)" <[email-masked]>
Date: Thu, 5 Mar 2026 14:28:08 +0000

On Thu, Mar 05, 2026 at 02:13:24PM +0000, Conor Dooley wrote:
> On Thu, Mar 05, 2026 at 05:56:15AM -0800, Charles Perry wrote:
> > On Thu, Mar 05, 2026 at 09:42:19AM +0000, Conor Dooley wrote:
> > > On Wed, Mar 04, 2026 at 09:37:23AM -0800, Charles Perry wrote:
> > > > On Wed, Mar 04, 2026 at 04:23:30PM +0000, Conor Dooley wrote:
> > > > 
> > > > Are you able to check register 23, bit 13 of your PHY by any chance? Maybe
> > > > with the mdio/mii commands in U-Boot if you have that.
> > > 
> > > "mii read addr 23" returns 0660 for both PHYs in U-Boot.
> > 
> > Oh, I think you fell into a trap of U-Boot's mii command.
> > 
> > The arguments are always in hex even if you dont prepend "0x".
> 
> Eh no, actually I thought that you meant register 0x23. I'm not used to
> register addresses being given in decimal.
> 
> > What "mii read 8 23" did is most likely read register 0x23, masked with
> > 0x1f because clause 22 has only 32 registers. So it read register 0x3 which
> > is the device identifier 2 register: 0x0660.
> > 
> > The exact command should be "mii read 8 0x17", "mii read 9 0x17".
> 
> Both read back 2004

It would would be good to see the content of 0x1b, specifically bit 13.
The PHY supports AN bypass, and I suspect bit 13 is zero, which means
in combination with bit 13 set in 0x17, the PHY must complete the SGMII
exchange with the MAC.

I suggest something like the following in vitesse.c for this PHY:

#define VSC8662_EXT_CON1		0x17
#define VSC8662_EXT_CON_MAC_AN		BIT(13)

#define VSC8662_MAC_AN			0x1b
#define VSC8662_MAC_AN_BYPASS		BIT(13)

static unsigned int vsc8662_inband_caps(struct phy_device *phydev,
					phy_interface_t interface)
{
	if (interface == PHY_INTERFACE_MODE_SGMII)
		return LINK_INBAND_DISABLE | LINK_INBAND_ENABLE |
		       LINK_INBAND_BYPASS;

	return 0;
}

static int vsc8662_config_inband(struct phy_device *phydev, unsigned int modes)
{
	bool changed = false;
	u16 mask;
	int ret;

	mask = VSC8662_EXT_CON_MAC_AN;
	ret = phy_modify_changed(phydev, VSC8662_EXT_CON1, mask,
				 modes & (LINK_INBAND_ENABLE |
				 	  LINK_INBAND_BYPASS) ? mask : 0);
	if (ret > 0)
		changed = true;
	else if (ret < 0)
		return ret;

	mask = VSC8662_MAC_AN_BYPASS;
	ret = phy_modify(phydev, VSC8662_MAC_AN, mask,
			 modes & LINK_INBAND_BYPASS ? mask : 0);
	if (ret < 0)
		return ret;

	return genphy_soft_reset(phydev);
}

and the appropriate initialisers in the phy_driver struct.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!